/* Copyright (c) 2016, ENEA Software AB
 * Copyright (c) 2016, Nokia
 * All rights reserved.
 *
 * SPDX-License-Identifier:     BSD-3-Clause
 */

#ifndef __NETWRAP_COMMON_H__
#define __NETWRAP_COMMON_H__

#ifndef RTLD_NEXT
#define _GNU_SOURCE
#endif
#include <dlfcn.h>

#define LIBC_FUNCTION(func) do {			\
		libc_##func = dlsym(RTLD_NEXT, #func);	\
		if (dlerror()) {			\
			errno = EACCES;			\
			exit(1);			\
		}					\
	} while (0)

#define IS_OFP_SOCKET(_fd) (_fd >= OFP_SOCK_NUM_OFFSET)

#endif /* __NETWRAP_COMMON_H__ */


